<template>
  <div class="app-container">
    <el-form
      v-show="showSearch"
      ref="queryForm"
      :inline="true"
      :model="queryParams"
      label-width="68px"
      size="small"
    >
      <el-form-item label="用户名称" prop="userName">
        <el-input
          v-model="queryParams.userName"
          clearable
          placeholder="请输入用户名称"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button
          icon="el-icon-search"
          size="mini"
          type="primary"
          @click="handleQuery"
        >搜索
        </el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
        >重置
        </el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['base:basepublicuser:add']"
          icon="el-icon-plus"
          plain
          size="mini"
          type="primary"
          @click="handleAdd"
        >新增
        </el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['base:basepublicuser:edit']"
          :disabled="single"
          icon="el-icon-edit"
          plain
          size="mini"
          type="success"
          @click="handleUpdate"
        >修改
        </el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['base:basepublicuser:remove']"
          :disabled="multiple"
          icon="el-icon-delete"
          plain
          size="mini"
          type="danger"
          @click="handleDelete"
        >删除
        </el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['base:basepublicuser:export']"
          icon="el-icon-download"
          plain
          size="mini"
          type="warning"
          @click="handleExport"
        >导出
        </el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="basepublicuserList"
      :row-key="getRowKeys"
      @expand-row-keys="expands"
      @selection-change="handleSelectionChange"
      @expand-change="expandChange"
    >
      <el-table-column align="center" type="selection" width="55"/>
      <el-table-column type="expand">
        <template slot-scope="props">
          <el-table :data="props.row.items || []" row-key="monitorId">
            <el-table-column align="center" label="表具编号" prop="monitorId"/>
            <el-table-column align="center" label="表具类型" prop="publicShareType">
              <template slot-scope="scope">
                <dict-tag
                  :options="dict.type.public_share_type"
                  :value="scope.row.publicShareType"
                />
              </template>
            </el-table-column>
            <el-table-column
              align="center"
              label="表具名称"
              prop="monitorName"
            />
          </el-table>
        </template>
      </el-table-column>
      <el-table-column v-if="false" align="center" label="主键" prop="id"/>
      <el-table-column align="center" label="用户名称" prop="userName"/>
      <el-table-column align="center" label="公摊面积" prop="area"/>
      <el-table-column align="center" label="备注" prop="remark"/>
      <el-table-column
        align="center"
        class-name="small-padding fixed-width"
        label="操作"
      >
        <template slot-scope="scope">
          <el-button
            v-hasPermi="['base:basepublicuser:edit']"
            icon="el-icon-edit"
            size="mini"
            type="text"
            @click="handleUpdate(scope.row)"
          >修改
          </el-button
          >
          <el-button
            v-hasPermi="['base:basepublicuser:remove']"
            icon="el-icon-delete"
            size="mini"
            type="text"
            @click="handleDelete(scope.row)"
          >删除
          </el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :limit.sync="queryParams.pageSize"
      :page.sync="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改公摊用户对话框 -->
    <el-dialog :title="title" :visible.sync="open" append-to-body width="550px">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="用户名称" prop="userName">
          <el-input v-model="form.userName" placeholder="请输入用户名称"/>
        </el-form-item>
        <el-form-item label="用户所属业主表" prop="monitorId">
          <el-select
            v-model="form.publicShareIds"
            filterable
            multiple
            placeholder="请选择业主表"
          >
            <el-option
              v-for="dict in monitorList"
              :key="dict.monitorId"
              :label="dict.monitorName"
              :value="dict.monitorId"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="用户所属公摊表" prop="monitorId">
          <el-select
            v-model="form.publicMonitorIds"
            filterable
            multiple
            placeholder="请选择公摊表"
          >
            <el-option
              v-for="dict in publicMonitorList"
              :key="dict.monitorId"
              :label="dict.monitorName"
              :value="dict.monitorId"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="面积" prop="area">
          <el-input v-model="form.area" placeholder="请输入面积"/>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input
            v-model="form.remark"
            placeholder="请输入内容"
            type="textarea"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listBasepublicuser,
  getBasepublicuser,
  delBasepublicuser,
  addBasepublicuser,
  updateBasepublicuser,
  childlist,
  monitorInfoList,
  basepublicuserexport,
} from "@/api/ems/base/basepublicuser";

export default {
  name: "Basepublicuser",
  dicts: ["public_share_type"],
  data() {
    return {
      // 计量设备
      monitorList: [],
      publicMonitorList: [],
      // 展开行id
      expands: [],
      // dict: ["public_share_type"],
      // dicts: ["public_share_type"],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 公摊用户表格数据
      basepublicuserList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      // 是否展开
      isexpand: false,
      getRowKeys(row) {
        return row.id;
      },
    };
  },
  created() {
    this.getList();
    this.monitorInfoList();
    this.publicMonitorListF()
  },
  methods: {
    expandChange(r, r1) {
      console.log(this.expands, r, r1);
      if (r1.some((item) => item.id == r.id))
        childlist({id: r.id}).then((res) => {
          let row = this.basepublicuserList.find((item) => item.id == r.id);
          row.items = res.rows;
          this.basepublicuserList = this.basepublicuserList.slice(0);
          this.expands = r1;
        });
    },
    /** 查询公摊用户列表 */
    getList() {
      this.loading = true;
      listBasepublicuser(this.queryParams).then((response) => {
        this.basepublicuserList = response.rows;
        this.basepublicuserList.forEach((item) => {
          Object.assign(item, {items: []});
        });
        this.total = response.total;
        this.loading = false;
        if (this.expands.length > 0) {
          this.expands.forEach((item, index) => {
            this.expandChange(item, this.expands);
          });
        }
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        userName: null,
        createBy: null,
        publicShareIds: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
        publicMonitorIds: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加公摊用户";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      const _this = this;
      this.open = true;
      this.reset();
      Object.assign(this.form, {...row});
      const id = row.id || this.ids;
      childlist({id: row.id}).then((res) => {
        console.log(res);
        _this.form.publicShareIds = [];
        _this.form.publicMonitorIds = [];
        res.rows.forEach((item) => {
          if (item.publicShareType === 1) {
            _this.form.publicShareIds.push(item.monitorId);
          }
          if (item.publicShareType === 0) {
            _this.form.publicMonitorIds.push(item.monitorId);
          }
        });
        // let row = this.basepublicuserList.find((item) => item.id == r.id);
        // row.items = res.rows;
        // this.basepublicuserList = this.basepublicuserList.slice(0);
      });
    },
    async monitorInfoList() {
      const res = await monitorInfoList({publicShareType: 1});
      this.monitorList = res;
    },
    async publicMonitorListF() {
      const res = await monitorInfoList({publicShareType: 0});
      this.publicMonitorList = res;
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateBasepublicuser(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            console.log(this.form)
            addBasepublicuser(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      console.log(this.ids);
      this.ids = this.ids.toString();
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除公摊用户编号为"' + ids + '"的数据项？')
        .then(function () {
          return delBasepublicuser({
            ids: ids,
          });
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {
        });
    },
    /** 导出按钮操作 */
    handleExport() {
      let paramsexport = JSON.parse(JSON.stringify(this.queryParams));
      delete paramsexport.pageSize;
      delete paramsexport.pageNum;
      this.download(
        "energy/base/basepublicuser/export",
        {
          ...paramsexport,
        },
        `basepublicuser_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
